/*******************************************************************************/
/*** This module was written 22. May 1993 by Katzlberger Thomas, Innsbruck,  ***/
/*** AUSTRIA and is Part of the distribution of the Super Solitaire App, as  ***/
/*** an example module.                                                      ***/
/***                                                                         ***/
/*** YOU MAY:   - reuse this code for writing Super Solitaire Bundles.       ***/
/***            - modify the module as long as you rename the Class and      ***/
/***              replace the author's message by your own.                  ***/
/***            - reuse this code for any Public Domain, especially not      ***/
/***              commercial offer.                                          ***/
/***                                                                         ***/
/*** =========>>> Best results setting TAB-Size to 4 characters <<<========= ***/
/***                                                                         ***/
/*******************************************************************************/

/*******************************   INTERFACES   ********************************/

#import "BlackJack.h"

	@interface BlackJack(Bundle)
	
	- loadBundle:sender;
	
	@end
	
	@interface BlackJack(Private)
	
	- setupViews;
	- (void) clearAll;
	- dealOut;
	
	@end
	
	@interface BlackJack(Window)
	@end
	
	@interface BlackJack(GameLogic)
	@end

/*******************************     BUNDLE     ********************************/
	@implementation BlackJack(Bundle)
	
	- loadBundle:bundle
	{		
		char p[1025];

		[[NXHelpPanel new] addSupplement:"Help" inPath:[bundle directory]];
		[bundle getPath:p forResource:[[self class] name] ofType:"nib"];		
		[NXApp loadNibFile:p owner:self];
		
		return self;
	}
		
	@end
	
/*******************************     WINDOW     ********************************/
	@implementation BlackJack(Window)
	
	- windowWillClose:sender
	{
		[[MainDelegate new] collect:nil];
		[NXApp delayedFree:self];
		return self;
	}
		
	@end
	
/*******************************     PRIVATE    ********************************/
@implementation BlackJack(Private)

- setupViews
{
	[toTalon enableDrag:NO];

	[toPlayStack1 setDeltaX:CARD_WIDTH+1];
	[toPlayStack2 setDeltaX:CARD_WIDTH+1];

	[toPlayStack1 enableDrop:NO];

	[toPlayStack1 enableDrag:NO];
	[toPlayStack2 enableDrag:NO];

	return self;
}

- (void) clearAll
{
	[toPlayStack1 clear];
	[toPlayStack2 clear];
	
	[toTalon clear];
}

- dealOut
{
	return self;
}

@end

@implementation BlackJack

- initBundle:bundle
{
	[super init];
	
	#include "../Demo.h"

	[self loadBundle:bundle];
	[self setupViews];

	rule = 0; 

	[self newGame:self];

	[toMyWindow makeKeyAndOrderFront:self];

	return self;
}

- free
{
	return [super free];
}

- deal:sender
{
	if([toTalon count]<15) [self newGame:self];

	rienNeVaPlus = YES;

	[toPlayStack1 clear];
	[toPlayStack2 clear];

	[toScoreForm setStringValue:"" at:0];
	[toScoreForm setStringValue:"" at:1];

	[[toTalon lastCard] performDragToView:toPlayStack1];
	[[toTalon lastCard] performDragToView:toPlayStack1];
		
	[[[toTalon lastCard] showFace:YES] performDragToView:toPlayStack2];
	[[[toTalon lastCard] showFace:YES] performDragToView:toPlayStack2];
	[DraggableView sync];

	int sum=0,ace=0,v;

	for(int i=0;i<2;i++)
	{	v = [[toPlayStack2 objectAt:i] value];

		if(v>10) v=10;
		sum  += v;

		if(v==CARD_ACE) 			{	sum += 10;	ace++;	}	
		while((sum>21) && (ace>0))	{	sum -= 10;	ace--;	}
	}

	[toScoreForm setIntValue:sum at:1];

	if(sum>20)	[self stand:self];

	return self;
}

- newGame:sender
{	
	[self clearAll];

	[toTalon newDoubleDeck];
	[toTalon shuffle];

	flips = 1;
	char  str[20];
	sprintf(str,"Flips: %i",flips);
	[toFlipButton setEnabled:YES];
	[toFlipButton setTitle:str];
	
	rienNeVaPlus = NO;

	if([toAccount intValueAt:1]<=0)
		[toAccount setIntValue:500 at:1];
		
    return self;
}

- flipPile:sender	// do not use sender (may be MainDelegate)
{
	return self;
}

- stand:sender
{
	int sum = 0,i,v,ace=0;
	id  card;
	
	if(rienNeVaPlus == NO) return self;
	
	[toPlayStack1 showFaces:YES];

	for(i=0;i<(int)[toPlayStack1 count];i++)
	{	v = [[toPlayStack1 objectAt:i] value];

		if(v>10) v=10;
		sum  += v;

		if   (v==CARD_ACE) 			{	sum += 10;	ace++;	}	
		while((sum>21) && (ace>0))	{	sum -= 10;	ace--;	}
	}

	while(sum < 17)
	{	[[card = [toTalon lastCard] showFace:YES] performDragToView:toPlayStack1];
		[DraggableView sync];
	
		v = [card value];

		if(v>10) v=10;
		sum  += v;
		
		if   (v==CARD_ACE)			{	sum += 10;	ace++;	}
		while((sum>21) && (ace>0))	{	sum -= 10; ace--;	}
	}

	[toScoreForm setIntValue:sum at:0];
	
	BOOL lost = NO;
	
	rienNeVaPlus = NO;

	if([toScoreForm intValueAt:1]>21) lost = YES;
	if([toScoreForm intValueAt:1]<[toScoreForm intValueAt:0] && [toScoreForm intValueAt:0]<22) 
		lost = YES;
	
	if(lost == NO && [toScoreForm intValueAt:1] == [toScoreForm intValueAt:0])
		return self;
	
	if(lost)
	{	[toAccount setIntValue:[toAccount intValueAt:0]+[toMoney intValue] at:0];
		[toAccount setIntValue:[toAccount intValueAt:1]-[toMoney intValue] at:1];
	}
	else
	{	[toAccount setIntValue:[toAccount intValueAt:0]-[toMoney intValue] at:0];
		[toAccount setIntValue:[toAccount intValueAt:1]+[toMoney intValue] at:1];
	}

	if([toMoney intValue]>=[toAccount intValueAt:1])
		[toMoney setIntValue:[toAccount intValueAt:1]];
	
	return self;
}

- nextCard:sender
{
	[sender setEnabled:NO];
	[sender perform:@selector(setEnabled:) with:(id)YES afterDelay:200 cancelPrevious:YES];

	[[[toTalon lastCard] showFace:YES] performDragToView:toPlayStack2];
	[DraggableView sync];
	
	int sum=0,ace=0,v;
	
	for(int i=0;i<(int)[toPlayStack2 count];i++)
	{	v = [[toPlayStack2 objectAt:i] value];

		if(v>10) v=10;
		sum += v;

		if   (v==CARD_ACE) 			{	sum += 10;	ace++;	}	
		while((sum>21) && (ace>0))	{	sum -= 10;	ace--;	}
	}

	[toScoreForm setIntValue:sum at:1];

	if(sum>20)	[self stand:self];

	return self;
}

- right:sender
{
	if(rienNeVaPlus) return self;
	if([toMoney intValue]>=[toAccount intValueAt:1]) return self;

	[toMoney setIntValue:[toMoney intValue]+1];
	return self;
}

- left:sender
{
	if(rienNeVaPlus) return self;

	if([toMoney intValue]<1) return self;
	[toMoney setIntValue:[toMoney intValue]-1];
	return self;
}

- toggleRule:sender
{
	if(NX_ALERTDEFAULT!=NXRunAlertPanel(0,"This will redeal !\nAre you sure ?","YES","NO",0))
		return [sender setState:![sender state]];
		
	if(rule==0) rule=1; else rule=0;
	[self newGame:self];
	
	return self;
}

@end

/********************************   GAMELOGIC  ********************************/
@implementation BlackJack(GameLogic)

/******************************************************************************/
/*** you have to comment these two functions out if you do not use them !!! ***/
/******************************************************************************/

/*
- (BOOL) dropStack:stack acceptsCard:upperCard onTopOf:lowerCard
{
	return NO;
}
*/

- (BOOL) playStack:stack acceptsCard:upperCard onTopOf:lowerCard
{
	return YES;
}

@end

