/*******************************   INTERFACES   ********************************/

#import "TheClock.h"
#import "TheClockDropStack.h"

	@interface TheClock(Bundle)
	
	- loadBundle:sender;
	
	@end
	
	@interface TheClock(Private)
	
	- setupViews;
	- (void) clearAll;
	- dealOut;
	
	@end
	
	@interface TheClock(Window)
	@end
	
	@interface TheClock(GameLogic)
	
	- hintUsed:sender;
	
	@end

/*******************************     BUNDLE     ********************************/
	@implementation TheClock(Bundle)
	
	- loadBundle:bundle
	{		
		char p[1025];

		[[NXHelpPanel new] addSupplement:"Help" inPath:[bundle directory]];
		[bundle getPath:p forResource:[[self class] name] ofType:"nib"];		
		[NXApp loadNibFile:p owner:self];
		
		return self;
	}
		
	@end
	
/*******************************     WINDOW     ********************************/
	@implementation TheClock(Window)
	
	- windowWillClose:sender
	{
		[[MainDelegate new] collect:nil];
		[NXApp delayedFree:self];
		return self;
	}
	
	@end
	
/*******************************     PRIVATE    ********************************/
@implementation TheClock(Private)

- setupViews
{
	[toDropper1  setValueToAccept:1];
	[toDropper2  setValueToAccept:2];
	[toDropper3  setValueToAccept:3];
	[toDropper4  setValueToAccept:4];
	[toDropper5  setValueToAccept:5];
	[toDropper6  setValueToAccept:6];
	[toDropper7  setValueToAccept:7];
	[toDropper8  setValueToAccept:8];
	[toDropper9  setValueToAccept:9];
	[toDropper10 setValueToAccept:10];
	[toDropper11 setValueToAccept:11];
	[toDropper12 setValueToAccept:12];
	[toDropper13 setValueToAccept:13];
	
	[toDropper1   rotateTo:-30.0];
	[toDropper2   rotateTo:-60.0];
	[toDropper3   rotateTo:-90.0];
	[toDropper4   rotateTo:-120.0];
	[toDropper5   rotateTo:-150.0];
	[toDropper6   rotateTo:180.0];
	[toDropper7   rotateTo:150.0];
	[toDropper8   rotateTo:120.0];
	[toDropper9   rotateTo:90.0];
	[toDropper10  rotateTo:60.0];
	[toDropper11  rotateTo:30.0];

	float pi=3.141592711;
	float a=pi/6,r=200.0;
	NXCoord x=350.0,y=350.0;

	[toDropper1   moveTo:r*sin(a)+x-36*cos(a) :r*cos(a)+y+36*sin(a)];	a=2*pi/6;
	[toDropper2   moveTo:r*sin(a)+x-36*cos(a) :r*cos(a)+y+36*sin(a)];	a=3*pi/6;
	[toDropper3   moveTo:r*sin(a)+x-36*cos(a) :r*cos(a)+y+36*sin(a)];	a=4*pi/6;
	[toDropper4   moveTo:r*sin(a)+x-36*cos(a) :r*cos(a)+y+36*sin(a)];	a=5*pi/6;
	[toDropper5   moveTo:r*sin(a)+x-36*cos(a) :r*cos(a)+y+36*sin(a)];	a=6*pi/6;
	[toDropper6   moveTo:r*sin(a)+x-36*cos(a) :r*cos(a)+y+36*sin(a)];	a=7*pi/6;
	[toDropper7   moveTo:r*sin(a)+x-36*cos(a) :r*cos(a)+y+36*sin(a)];	a=8*pi/6;
	[toDropper8   moveTo:r*sin(a)+x-36*cos(a) :r*cos(a)+y+36*sin(a)];	a=9*pi/6;
	[toDropper9   moveTo:r*sin(a)+x-36*cos(a) :r*cos(a)+y+36*sin(a)];	a=10*pi/6;
	[toDropper10  moveTo:r*sin(a)+x-36*cos(a) :r*cos(a)+y+36*sin(a)];	a=11*pi/6;
	[toDropper11  moveTo:r*sin(a)+x-36*cos(a) :r*cos(a)+y+36*sin(a)];	a=2*pi;
	[toDropper12  moveTo:r*sin(a)+x-36*cos(a) :r*cos(a)+y+36*sin(a)];
	[toDropper13  moveTo:x-36 :y-55-30];

	[toMyWindow display];
	return self;
}

- (void) clearAll
{
	[toDropper1 clear];
	[toDropper2 clear];
	[toDropper3 clear];
	[toDropper4 clear];
	[toDropper5 clear];
	[toDropper6 clear];
	[toDropper7 clear];
	[toDropper8 clear];
	[toDropper9 clear];
	[toDropper10 clear];
	[toDropper11 clear];
	[toDropper12 clear];
	[toDropper13 clear];
	
	[toTalon clear];
	[toBlock clear];
}

- dealOut
{
	return self;
}

@end

@implementation TheClock

- initBundle:bundle
{
	[super init];
	
	#include "../Demo.h"

	[self loadBundle:bundle];
	[self setupViews];

	rule = 0; 

	[toMyWindow makeKeyAndOrderFront:self];
	[self newGame:self];

	return self;
}

- free
{
	return [super free];
}

- deal:sender
{
	return self;
}

- newGame:sender
{	
	[[MainDelegate new] collect:self];

	[self clearAll];
	
	[toTalon newDeck];
	[toTalon shuffle];
	cardsOut = 52;
	
	hints = 0;
	[self hintUsed:self];
	flips = 1;

	char  str[20];
	sprintf(str,"Flips: %i",flips);
	[toFlipButton setEnabled:YES];
	[toFlipButton setTitle:str];

	[TheClockDropStack newGame];

    return self;
}

- flipPile:sender	// do not use sender (may be MainDelegate)
{
	if([toTalon isEmpty] == NO)	return self;

	if(flips<=0) return self;
	flips--;
	if(flips<=0) [toFlipButton setEnabled:NO];
	char str[20];
	sprintf(str,"Flips: %i",flips);
	[toFlipButton setTitle:str];

	id card;
	
	while(card = [toBlock removeCard])
		[toTalon addCard:card];
		
	return self;
}

- nextCard:sender
{
	[sender setEnabled:NO];
	[sender perform:@selector(setEnabled:) with:(id)YES afterDelay:200 cancelPrevious:YES];

	[[toTalon lastCard] performDragToView:toBlock];

	return self;
}

- toggleRule:sender
{
	if(NX_ALERTDEFAULT!=NXRunAlertPanel(0,"This will redeal !\nAre you sure ?","YES","NO",0))
		return [sender setState:![sender state]];
		
	if(rule==0) rule=1; else rule=0;
	[self newGame:self];
	
	return self;
}

@end

/********************************   GAMELOGIC  ********************************/
@implementation TheClock(GameLogic)

/******************************************************************************/
/*** you have to comment these two functions out if you do not use them !!! ***/
/******************************************************************************/

/*
- (BOOL) dropStack:stack acceptsCard:upperCard onTopOf:lowerCard
{
	return NO;
}

- (BOOL) playStack:stack acceptsCard:upperCard onTopOf:lowerCard
{
	return NO;
}
*/

- dropStack:stack cardDropped:card
{
	cardsOut --;
	
	if(cardsOut==0)
		[[MainDelegate new] gameWon];
	
	return self;
}

- dropStack:stack cardRemoved:card
{
	cardsOut ++;
	return self;
}	

- playStack:playStack cardRemoved:card
{
	return self;
}

- playStack:stack cardDropped:card
{
	return self;
}

- blockStack:stack cardDropped:card
{
	return self;
}

- talonStack:stack cardRemoved:card		// card has no superview at this point !!
{
	return self;
}

- (int)hints
{
	return hints;
}

- hintUsed:sender
{
	static char title[1024] = "";
	char help[1024];
	
	if(title[0]==0) strcpy(title,[toMyWindow title]);
	
	if(hints==0)
		strcpy(help,title);
	else
	{	sprintf(help,"%s Hints: %i",title,hints);
		cardsOut++; // this disables the Bonus
	}
	
	[toMyWindow setTitle:help];
	hints++;
	
	return self;
}

@end

