//

#import <ReusableObjects/RODraggableImageView.h>

#define CARD_HEIGHT 	110
#define CARD_WIDTH	 	73

#define CARD_HEARTS 	0
#define CARD_DIAMONDS 	1
#define CARD_CLUBS		2
#define CARD_SPADES		3

#define CARD_ACE		1
#define CARD_KING		13

#define CARD_BLACK		0
#define CARD_RED		1

@interface Card:RODraggableImageView
{
    struct
	{
#ifdef __BIG_ENDIAN__
        unsigned int value:10;		// 1023
		unsigned int kind:6;		// 64
		unsigned int color:6;		// 64
		unsigned int reserved:10;
#else
		unsigned int reserved:10;
		unsigned int color:6;		// 64
		unsigned int kind:6;		// 64
        unsigned int value:10;		// 1023
#endif
	} caFlags;
}

+ (int) maxCardsForInit;			// returns: 51

- init:(int)card;					// StandardPokerCard range 0-51
- initWithIcon:(const char*)name value:(int)vl kind:(unsigned int)ki color:(unsigned int)cl;

- showFace:(BOOL)s;
- (BOOL)faceing;

- (int) value;
- (unsigned char) kind;
- (unsigned char) color;
- (BOOL)isRed;

- erase;

@end