// RODatabaseObject .m 12.1.93

#ifndef __RODBObject__
#define __RODBObject__

#ifdef __GNUG__
extern "Objective-C" {
#endif

#import <objc/Object.h>

#ifdef __GNUG__
}
#endif

#import <ReusableObjects/RODatabaseManager.h>

@interface RODatabaseObject:Object
{
	RODatabaseManager*	myDBM;
	handle				myHandle;
	BOOL				locked;
}

+ (RODatabaseManager*)openDatabase;
+ (RODatabaseManager*)openDatabaseFromFile:(const char*)file;
+ (RODatabaseManager*)openDatabaseFromFile:(const char*)file andStore:(const char*)s; 
+ (RODatabaseManager*)openDatabaseReadonly;

+ setDatabaseManager:(RODatabaseManager*)dbm;
+ (RODatabaseManager*)databaseManager;
	
+ (BOOL) startTransaction;
+ (BOOL) commitTransaction;
+ (BOOL) abortTransaction;

+ (int) errorNumber;
+ (const char*) errorString;

+ loadFromHandle:(handle)h;

- initHandle:(handle)h;			// needs a read message to get data from DB

- (handle) handle;
- (const char*) handleString;	// debuggning, ...

- setDatabaseManager:(RODatabaseManager*)dbm;
- (RODatabaseManager*)databaseManager;

- (handle) insert;
- (handle) update;
- (handle) delete;

- (handle) read;				// reverts
- (handle) load;				// locks

- (handle) replace:(handle)h;

- (BOOL  ) isLocked;
- (handle) lock;
- (handle) unlock;

@end

#endif
