// ROModTracker.h 6.2.1994

#import <ReusableObjects/ROThread.h>

#ifdef __GNUG__
extern "Objective-C" {
#endif

#import <appkit/appkit.h>
#import "song.h"

#ifdef __GNUG__
}
#endif

// #defines see song.h !!!

@interface ROModTracker:ROThread
{
	id 	   toProgress;
	
	BOOL   stereo,addFiles;
	int	   samplingRate,start,mix,transpose,oversampling,
		   buffers,pages,cntFiles,capacity,playmode;

    struct ROMpref pref;
    struct ROMsong *song;
	
	char **files;
}

+ new;

- setMonoCodec;
- setStereo11kHz;	// default !
- setStereo22kHz;

- setUseBuffers:(int)b pages:(int)p;	// use before first play !
- setSamplingRate:(int)f;
- (int)samplingRate;
- setOversampling:(int)f;
- (int)oversampling;
- setStereo:(BOOL)s;
- (BOOL)stereo;
- setMix:(float)s;
- (float)mix;
- setPlayMode:(int)m;
- (int)playmode;
- setSpeed:(int)sp;
- (int)speed;

- toggleEcho:sender;
- takeSpeedFrom:sender;
- takeSpeedFromTag:sender;
- takeSRateFromTag:sender;
- takeOversamplingFromTag:sender;
- takeSamplingRateFrom:sender;
- takeOversamplingFrom:sender;
- takeStereoFrom:sender;
- takeMixFrom:sender;
- takeBuffersFrom:sender;
- takePlayModeFrom:sender;
- takeEchoSetupFrom:sender;

- readFile:(const char*)f;
- dumpMod;
- play;

- setFromOpenPanel:sender;
- addFromOpenPanel:sender;
- setFiles:(const char* const*)f directory:(const char*)dir add:(BOOL)b; // dir==NULL if not

- addFile:(const char* )f;
- playFile:(const char*)f;
- playFiles:(const char* const*)f;
- playFromOpenPanel:sender;

- previous:sender;
- next:sender;
- start:sender;
- stop:sender;
- pause:sender;

@end
