// RORegex.h created by Katzlberger Thomas (cat) - So 15. Mrz 1994    V 1.3 
// (c) Copyright 1994 by Katzlberger Thomas 

#ifdef __GNUG__
extern "Objective-C" {
#endif

#import <objc/Object.h>

#ifdef __GNUG__
}
#endif

#import "RORegexTypes.h"

#define RORE_SYX_NORMAL     	0x0000
#define RORE_SYX_ESCAPE_ALL 	0x0001
#define RORE_SYX_C_WORDSTYLE	0x0002		// wordchar == [_.] . will get normal char
#define RORE_SYX_SHELL			0x0002		// wordchar == [_.] . will get normal char

#define RORE_SYX_BEST_C (RORE_SYX_ESCAPE_ALL || RORE_SYX_C_WORDSTYLE)

#define RORE_COMPILE_OK	rerr_no_error
#define RORE_DID_MATCH	rerr_no_error
#define RORE_FOUND		rerr_no_error

#define RORE_NO_MATCH	rerr_no_match
#define RORE_NOT_FOUND	rerr_not_found

#ifndef DEBUG
#define regops unsigned short
#endif

@interface RORegex:Object
{
	int		syntax;

	regops	compileBuffer[1025];		// enum == int size
	regops	*matchBuffer,*currentop;
	
	char	fastMatch[20];			// exact matches for fast access
	int     fastOffset;
	
	char*	commandCharTranslation;
	
	int		selStart,selEnd;
	int		tselStart,tselEnd;
	
	int		stepSize;
	
	BOOL	debugMode;
}

//******************************************************************************************
//*** EASY INTERFACE:																	****
//******************************************************************************************

- init;
- initWithSyntax:(unsigned int)s;

- setSyntax:(unsigned int)s;
- (unsigned int)syntax;

- setDebug:(BOOL)b;

- (const char*)errorStringFor:(regerr)err;

- (int)selStart;					// to be passed to [text setSel::]
- (int)selEnd;						// to be passed to [text setSel::]
- (int)selLength;

//*** methods work on NULL terminated strings, full range and compile the pattern **********

- (regerr)match:(const char*)what  in:(const char*)string;
- (regerr)search:(const char*)what in:(const char*)string;
- (regerr)search:(const char*)what in:(const char*)string start:(int)st backwards:(BOOL)bw;
- (regerr)search:(const char*)what in:(const char*)string ofLength:(int)l;

//************************************ FULL functionality **********************************
- (regerr)search:(const char*)what in:(const char*)s ofLength:(int)l start:(int)st 
		  step:(int)updown;

- (regerr)compilePattern:(const char*)what;
- (regerr)compilePattern:(const char*)what size:(int)length;
- (regerr)matchString:(const char*)s ofLength:(int)sz start:(int)where;
- (regerr)searchString:(const char*)s ofLength:(int)sz start:(int)where step:(int)t;

@end