// ROSoundEffect.h 5.6.1993

#ifdef __GNUG__
extern "Objective-C" {
#endif

#import <objc/Object.h>
#import <soundkit/Sound.h>
#import <soundkit/NXPlayStream.h>

#ifdef __GNUG__
}
#endif

@interface ROSoundEffect:Object
{
    Sound *sound;			// The sound data for this sound

    struct _ROSEflags
	{
	#ifdef __BIG_ENDIAN__
        unsigned int refCount:8;		// Number of play requests pending
		unsigned int limit:8;
		unsigned int freeWhenDone:1;	// Free when all are done
		unsigned int volume:8;
		unsigned int freeSound:1;
		unsigned int reserved:6;
	#else
		unsigned int reserved:6;
		unsigned int freeSound:1;
		unsigned int volume:8;
		unsigned int freeWhenDone:1;	// Free when all are done
		unsigned int limit:8;
        unsigned int refCount:8;		// Number of play requests pending	
	#endif
	} ROSEflags;
}

- soundEffectsOnOff:sender;

- initFromSoundfile:(const char *)path withLimit:(unsigned char)n;
- initFromSoundfile:(const char *)sound;

- initFromSection:(const char *)path withLimit:(unsigned char)n;
- initFromSection:(const char *)sound;

- sound;
- setSound:(Sound *)sobj;
- findAndSetSound:(const char *)name;
	// sets a shared sound (does not free snd) from soundTable or local path.
	// see +findSoundNamed: (Sound).

- (unsigned char)limit;
- setLimit:(unsigned char)l;

- (float)volume;
- setVolume:(float) vol;

// This function ensures that soundstreams will be reactivated (by calling:
// soundStream:didCompleteBuffer:) if lots of (>20) short sounds are played within
// one function without invoking the eventloop 
- playEvent;
- play:sender;
- play;
- play:(float)volume pan:(float)rads;
- (int)soundsPlaying;
- free;

+ (void)setSoundEnabled:(BOOL)flag;
+ (BOOL)soundEnabled;

+ (void)setMaxSoundStreams:(unsigned int)max;
+ (unsigned int)maxSoundStreams;

@end

