// StackProtocols: 
//	all these protocols are informal; they may be implemented by
//	the stacks logicEvaluator(usually the Delegate of ModuleWindow, the Module/Budle Object)
//  if the default behavior is inappropriate.

@protocol PlayStackLogic

- (BOOL) playStack:stack acceptsCards:list;				 // if this is implemented
- (BOOL) playStack:stack acceptsCard:upper onTopOf:lower;// this w. be called for hinting only
- (BOOL) playStack:stack mayDragCard:card;
- playStack:stack cardDropped:card;
- playStack:stack cardRemoved:card;

@end

@protocol TalonStackLogic

- (BOOL) talonStack:stack cardRemoved:card;

@end

@protocol BlockStackLogic

- (BOOL) blockStack:stack acceptsCard:upper onTopOf:lower;
- blockStack:stack cardDropped:card;
- blockStack:stack cardRemoved:card;

@end

@protocol DropStackLogic

- (BOOL) dropStack:stack acceptsCard:upper onTopOf:lower;
- dropStack:self cardDropped:card;
- dropStack:self cardRemoved:card;

@end

@protocol HandLogic

// - (BOOL) hand:stack mayDragCard:card;
- (BOOL) hand:stack acceptsCard:upper onTopOf:lower;
- hand:hand cardDropped:card;
- hand:hand cardRemoved:card;

@end

@protocol SingleStackLogic

- (BOOL) singleStack:stack acceptsCard:upper onTopOf:lower;
- singleStack:stack cardDropped:card;
- singleStack:stack cardRemoved:card;

@end
