// template.m 14.12.1993
/*******************************   INTERFACES   ********************************/

#import "template.h"

	@interface template(Bundle)
	
	- loadBundle:sender;
	
	@end
	
	@interface template(Private)
	
	- setupViews;
	- (void) clearAll;
	- dealOut;
	
	@end
	
	@interface template(Window)

	- windowWillClose:sender;

	@end
	
	@interface template(GameLogic)

	- hintUsed:mainDelegate;

	@end

/*******************************     BUNDLE     ********************************/
	@implementation template(Bundle)
	
	- loadBundle:bundle
	{		
		char p[1025];

		[[NXHelpPanel new] addSupplement:"HelpSupplement" inPath:[bundle directory]];
		[bundle getPath:p forResource:[[self class] name] ofType:"nib"];		
		[NXApp loadNibFile:p owner:self];
		
		return self;
	}
		
	@end
	
/*******************************     WINDOW     ********************************/
	@implementation template(Window)
	
	- windowWillClose:sender
	{
		[NXApp delayedFree:self];
		return self;
	}
		
	@end
	
/*******************************     PRIVATE    ********************************/
@implementation template(Private)

- setupViews
{
	return self;
}

- (void) clearAll
{
	[[MainDelegate new] clearAll:self];

	// [myStack clear];
}

- dealOut
{
	[[[toTalon lastCard] showFace:YES] performDragToView:toPlayStack1];
	[[[toTalon lastCard] showFace:YES] performDragToView:toPlayStack2];
	[[[toTalon lastCard] showFace:YES] performDragToView:toPlayStack3];
	[[[toTalon lastCard] showFace:YES] performDragToView:toPlayStack4];
	[[[toTalon lastCard] showFace:YES] performDragToView:toPlayStack5];
	[[[toTalon lastCard] showFace:YES] performDragToView:toPlayStack6];
	[[[toTalon lastCard] showFace:YES] performDragToView:toPlayStack7];
	[[[toTalon lastCard] showFace:YES] performDragToView:toPlayStack8];
	
	return self;
}

@end

@implementation template

- initBundle:bundle
{
	[super init];
	
	[self loadBundle:bundle];
	[self setupViews];

	rule = 0; 

	[toMyWindow makeKeyAndOrderFront:self];
	[self newGame:self];

	return self;
}

- free
{
	return [super free];
}

- deal:sender
{
	return self;
}

- newGame:sender
{	
	// Talon Default: no drop  , draggable
	// Block Default: droppable, draggable

	[self clearAll];

	hints = 0;
	[self hintUsed:[MainDelegate new]];

	[[toTalon newDoubleDeck] shuffle];  
	[toTalon flipCards:YES]; // del this line if you want cards with back up! forw. to Deck
	cardsOut = 104;
	
	flips = 1;
	
	char  str[20];
	sprintf(str,"Flips: %i",flips);
	[toFlipButton setEnabled:YES];
	[toFlipButton setTitle:str];
	
	[self dealOut];
	
    return self;
}

- flipPile:sender	// do not use sender (may be MainDelegate)
{
	if([toTalon isEmpty] == NO)	return self;

	if(flips<=0) return self;
	flips--;
	if(flips<=0) [toFlipButton setEnabled:NO];
	char str[20];
	sprintf(str,"Flips: %i",flips);
	[toFlipButton setTitle:str];
	
	id card;
	
	while(card = [toBlock removeCard])
		[toTalon addCard:card];
		
	return self;
}

- nextCard:sender
{
	[sender setEnabled:NO];
	[sender perform:@selector(setEnabled:) with:(id)YES afterDelay:200 cancelPrevious:YES];

	[[toTalon lastCard] performDragToView:toBlock];

	return self;
}

- toggleRule:sender
{
	if(NX_ALERTDEFAULT!=NXRunAlertPanel(0,"This will redeal !\nAre you sure ?","YES","NO",0))
		return [sender setState:![sender state]];
		
	if(rule==0) rule=1; else rule=0;
	[self newGame:self];
	
	return self;
}

- (int)hints
{	
	return hints;	// return -1 to signal that this game can't be scored
}

@end

/********************************   GAMELOGIC  ********************************/
@implementation template(GameLogic)

/*************************************************************************************/
/*** you have to comment these functions out if you use the default behavior !!!   ***/
/*************************************************************************************/

/*
- (BOOL) dropStack:stack acceptsCard:upperCard onTopOf:lowerCard
{
	return NO;	// YES = dropCard; NO = refuseCard; 3 = append default behavior 
}

- (BOOL) playStack:stack acceptsCard:upperCard onTopOf:lowerCard
{
	id upperStack = [upperCard superview];

	//	if([stack isEmpty]) return YES;
	
	//	if(([stack isEmpty]) && ([upperCard value] == CARD_KING)) return YES;

	//	descending same kind:
	//	if([upperCard kind] != [lowerCard kind]) return NO;
	//	if([upperCard value] == [lowerCard value]-1) return YES;

	//	ascending same kind:
	//	if([upperCard kind] != [lowerCard kind]) return NO;
	//	if([upperCard value] == [lowerCard value]+1) return YES;

	//	use [[upperCard superview] isKindOfClassNamed:"DropStack"]; to check
	//	or  [upperCard superview] == toTalon
	
	return NO;
}

	// implement if dragging and dropping differ !
	// here you may drop (should be impl. above) 4-5-6-5-4-3-2 but drag only: 6-5-4-3-2 
- (BOOL) playStack:stack mayDragCard:card;
{
	BOOL ok=YES;
	id   upper,lower;
	int  upDown = 0;

	for(int i=[[stack list] count]-1;i>=0;i--)
	{	upper = [[stack list] objectAt:i];
	
		if(upper == card) break;	// OK (return YES), finished
		
		lower = [[stack list] objectAt:i-1];

		if(upDown == 0)
			upDown = [upper value] - [lower value];
		
		if(upDown != [upper value] - [lower value])
			ok = NO;
		else
			ok = [self playStack:stack acceptsCard:upper onTopOf:lower];
		
		if(!ok) break;
	}
	
	return ok;
}

- playStack:stack cardRemoved:card		// card has no superview at this point !!
{
	return self;
}

- playStack:stack cardDropped:card		// card has no superview at this point !!
{
	return self;
}

- (BOOL) blockStack:stack acceptsCard:upperCard onTopOf:lowerCard
{
	return NO;
}

- blockStack:stack cardDropped:card		// card has no superview at this point !!
{
	return self;
}

- talonStack:stack cardRemoved:card		// card has no superview at this point !!
{
	[card showFace:YES];
	return self;
}

*/

- dropStack:stack cardDropped:card
{
	cardsOut --;
	
	if(cardsOut==0)
	{	[[MainDelegate new] gameWon];
		// if(youWanaDoSomethingAnnoying) doitHere();
	}
			
	return self;
}

- dropStack:stack cardRemoved:card
{
	cardsOut ++;
	return self;
}	

- hintUsed:mainDelegate
{
	static char title[1024] = "";
	char help[1024];
	
	if(title[0]==0) strcpy(title,[toMyWindow title]);
	
	if(hints>0)
		sprintf(help,"%s Hints: %i",title,hints);
	else
	{	strcpy(help,title);
		hints = -1;
	}
	
	[toMyWindow setTitle:help];
	
	hints++;

	return self;
}

@end

